<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_ZoneInfoRequest StructType
 * @subpackage Structs
 */
class JP_ZoneInfoRequest extends AbstractStructBase
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Type;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The ProductType
     * @var string
     */
    public $ProductType;
    /**
     * The Language
     * @var string
     */
    public $Language;
    /**
     * The JPDZone
     * @var string
     */
    public $JPDZone;
    /**
     * The ChildrenZones
     * @var bool
     */
    public $ChildrenZones;
    /**
     * Constructor method for JP_ZoneInfoRequest
     * @uses JP_ZoneInfoRequest::setType()
     * @uses JP_ZoneInfoRequest::setName()
     * @uses JP_ZoneInfoRequest::setProductType()
     * @uses JP_ZoneInfoRequest::setLanguage()
     * @uses JP_ZoneInfoRequest::setJPDZone()
     * @uses JP_ZoneInfoRequest::setChildrenZones()
     * @param string $type
     * @param string $name
     * @param string $productType
     * @param string $language
     * @param string $jPDZone
     * @param bool $childrenZones
     */
    public function __construct($type = null, $name = null, $productType = null, $language = null, $jPDZone = null, $childrenZones = null)
    {
        $this
            ->setType($type)
            ->setName($name)
            ->setProductType($productType)
            ->setLanguage($language)
            ->setJPDZone($jPDZone)
            ->setChildrenZones($childrenZones);
    }
    /**
     * Get Type value
     * @return string
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \EnumType\JP_ZoneInfoType::valueIsValid()
     * @uses \EnumType\JP_ZoneInfoType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \StructType\JP_ZoneInfoRequest
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JP_ZoneInfoType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JP_ZoneInfoType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \EnumType\JP_ZoneInfoType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_ZoneInfoRequest
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get ProductType value
     * @return string|null
     */
    public function getProductType()
    {
        return $this->ProductType;
    }
    /**
     * Set ProductType value
     * @param string $productType
     * @return \StructType\JP_ZoneInfoRequest
     */
    public function setProductType($productType = null)
    {
        // validation for constraint: string
        if (!is_null($productType) && !is_string($productType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productType, true), gettype($productType)), __LINE__);
        }
        $this->ProductType = $productType;
        return $this;
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \StructType\JP_ZoneInfoRequest
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($language, true), gettype($language)), __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
    /**
     * Get JPDZone value
     * @return string|null
     */
    public function getJPDZone()
    {
        return $this->JPDZone;
    }
    /**
     * Set JPDZone value
     * @param string $jPDZone
     * @return \StructType\JP_ZoneInfoRequest
     */
    public function setJPDZone($jPDZone = null)
    {
        // validation for constraint: string
        if (!is_null($jPDZone) && !is_string($jPDZone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($jPDZone, true), gettype($jPDZone)), __LINE__);
        }
        $this->JPDZone = $jPDZone;
        return $this;
    }
    /**
     * Get ChildrenZones value
     * @return bool|null
     */
    public function getChildrenZones()
    {
        return $this->ChildrenZones;
    }
    /**
     * Set ChildrenZones value
     * @param bool $childrenZones
     * @return \StructType\JP_ZoneInfoRequest
     */
    public function setChildrenZones($childrenZones = null)
    {
        // validation for constraint: boolean
        if (!is_null($childrenZones) && !is_bool($childrenZones)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($childrenZones, true), gettype($childrenZones)), __LINE__);
        }
        $this->ChildrenZones = $childrenZones;
        return $this;
    }
}
